/* @clake/react-bootstrap4-window v0.1.2 | by Clake
 * Copyright (c) 2018 Clake,
 * 2018-11-05T16:44:20+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _Common = require('./Common');

var _Common2 = _interopRequireDefault(_Common);

var _reactBootstrap = require('@clake/react-bootstrap4');

require('./css/CTable.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CTable = function (_React$Component) {
    _inherits(CTable, _React$Component);

    function CTable(props) {
        _classCallCheck(this, CTable);

        var _this = _possibleConstructorReturn(this, (CTable.__proto__ || Object.getPrototypeOf(CTable)).call(this, props));

        _this.scrollHandler = function (e) {
            _this.tableHeader.style.transform = 'translateX(-' + e.currentTarget.scrollLeft + 'px)';
        };

        _this.selectPageHandler = function (page) {
            if (typeof _this.props.onSelectPage === 'function') {
                _this.props.onSelectPage(page);
            }
        };

        _this.selectAll = function (e) {
            _this.select_all = e.target.checked;
            _Common2.default.map(_this.refs, function (item) {
                item.checked = _this.select_all;
            });
        };

        _this.state = {
            data: _this.props.data,
            dataCount: _this.props.dataCount,
            page: 1,
            select: _this.props.select
        };

        _this.select_all = false;

        _this.selectRows = {};

        _this.sortList = {};

        _this.initTableWidth();
        return _this;
    }

    _createClass(CTable, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.state.data !== nextProps.data) {
                this.select_all = false;
                this.selectRows = {};
                this.setState({
                    data: nextProps.data,
                    dataCount: nextProps.dataCount,
                    page: nextProps.page
                });
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            console.log(nextProps, nextState);
            return nextState.data !== this.state.data || nextState.tree !== this.state.tree;
        }
    }, {
        key: 'initTableWidth',
        value: function initTableWidth() {
            var _this2 = this;

            if (this.props.width) {
                this.width = 0;
                var reg = /(\d+)(px|rem|cm|mm|pt)$/;
                var matchs = this.props.width.match(reg);
                var unit = matchs[2];
                _react2.default.Children.map(this.props.children, function (item, key) {
                    if (item.props.width) {
                        var _matchs = item.props.width.match(reg);
                        _this2.width += parseInt(_matchs[1]);
                    }
                });
                if (this.props.select) {
                    this.width += 20;
                }
                this.width += unit;
            }
        }
    }, {
        key: 'changeHandler',
        value: function changeHandler(row, i) {
            var _this3 = this;

            return function (e) {
                if (e.target.checked) {
                    _this3.selectRows[i] = row;
                } else {
                    _this3.selectRows[i] = undefined;
                }
                if (typeof _this3.props.onCheck === "function") {
                    _this3.props.onCheck(e.target.checked, row);
                }
            };
        }
    }, {
        key: 'clickHandler',
        value: function clickHandler(row, i) {
            var _this4 = this;

            return function () {
                if (typeof _this4.props.onClick === 'function') {
                    _this4.props.onClick(row, i);
                }
            };
        }
    }, {
        key: 'sortHandler',
        value: function sortHandler(field, callback) {
            var _this5 = this;

            return function (e) {
                var dom = e.currentTarget;
                var sort_type = dom.dataset.sort || 'asc';
                callback(field, sort_type);
                dom.dataset.sort = sort_type === 'asc' ? 'desc' : 'asc';
                _this5.sortList[field] = sort_type;
                var child = dom.querySelector('i');
                child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
                child.classList.add('fa-sort-alpha-' + (sort_type === 'asc' ? 'down' : 'up'));
            };
        }
    }, {
        key: 'getSelectRows',


        /**
         * 得到所有选中的行
         * @returns {*}
         */
        value: function getSelectRows() {
            return _Common2.default.map(this.selectRows, function (item) {
                return item;
            });
        }

        /**
         * 设置选中的行
         * @param key 对应行数据的KEY值
         * @param list 要选中的数据值
         */

    }, {
        key: 'setSelectRows',
        value: function setSelectRows(key, list) {
            var _this6 = this;

            this.state.data.map(function (row, i) {
                if (list.indexOf(row[key]) !== -1) {
                    _this6.refs['row_' + i].setChecked(true);
                }
            });
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'table ck-table';
            //striped
            if (this.props.striped) {
                base = (0, _bind2.default)(base, 'table-striped');
            }
            //theme
            if (this.props.theme) {
                base = (0, _bind2.default)(base, 'table-' + this.props.theme);
            }
            //bordered
            if (this.props.bordered) {
                base = (0, _bind2.default)(base, 'table-bordered');
            }
            //hover
            if (this.props.hover) {
                base = (0, _bind2.default)(base, 'table-hover');
            }
            //sm
            if (this.props.sm) {
                base = (0, _bind2.default)(base, 'table-sm');
            }
            if (this.props.fontSm) {
                base = (0, _bind2.default)(base, 'table-font-sm');
            }
            //responsive
            if (this.props.responsive) {
                base = (0, _bind2.default)(base, 'table-responsive');
            }
            //nowrap
            if (this.props.noWrap) {
                base = (0, _bind2.default)(base, 'ck-ctable-nowrap');
            }
            return base;
        }
    }, {
        key: 'getMainClasses',
        value: function getMainClasses() {
            var base = 'ck-ctable-main d-flex flex-column';
            if (this.props.bordered) {
                base = (0, _bind2.default)(base, 'border');
            }
            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getStyles',
        value: function getStyles() {
            //default style
            var base = {};
            //width
            if (this.props.width) {
                base.width = this.props.width;
            }
            //height
            if (this.props.height) {
                base.height = this.props.height;
            }

            if (this.props.absolute) {
                base.position = 'absolute';
                base.top = this.props.y;
                base.left = this.props.x;
                if (_typeof(this.props.position) === 'object') {
                    base.top = this.props.position.top || this.props.y;
                    base.left = this.props.position.left || this.props.x;
                    base.right = this.props.position.right;
                    base.bottom = this.props.position.bottom;
                    base.width = undefined;
                    base.height = undefined;
                }
            }

            return _Common2.default.extend(base, this.props.style);
        }
    }, {
        key: 'getHeaderClasses',
        value: function getHeaderClasses() {
            var base = 'ck-ctable-header';
            if (this.props.headerTheme) {
                base = 'thead-' + this.props.headerTheme;
            }
            return (0, _bind2.default)(base, this.props.headClass);
        }
    }, {
        key: 'getTableStyles',
        value: function getTableStyles() {
            var base = {};

            if (this.width) {
                base.width = this.width;
            }

            return base;
        }
    }, {
        key: 'getBodyClasses',
        value: function getBodyClasses() {
            var base = 'ck-ctable-body flex-grow-1 d-flex flex-column';

            return base;
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { className: this.getMainClasses(), style: this.getStyles() },
                _react2.default.createElement(
                    'div',
                    { className: this.getBodyClasses() },
                    this.renderHeader(),
                    this.renderRows()
                ),
                this.renderFoot()
            );
        }
    }, {
        key: 'renderHeader',
        value: function renderHeader() {
            var _this7 = this;

            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this7.tableHeader = c;
                    } },
                _react2.default.createElement(
                    'table',
                    { className: this.getClasses(), style: this.getTableStyles() },
                    _react2.default.createElement(
                        'thead',
                        { className: this.getHeaderClasses() },
                        _react2.default.createElement(
                            'tr',
                            null,
                            this.state.select ? _react2.default.createElement(
                                'th',
                                { width: '20px' },
                                _react2.default.createElement('input', { type: 'checkbox', onChange: this.selectAll })
                            ) : null,
                            _react2.default.Children.map(this.props.children, function (item, key) {
                                if (!item || item.props.hide) {
                                    return null;
                                }
                                var align = item.props.align || _this7.props.align;
                                var style = {
                                    'textAlign': align
                                };
                                if (item.props.width) {
                                    style.width = item.props.width;
                                }
                                var sort_icon = 'sort';
                                if (_this7.sortList[item.props.field]) {
                                    sort_icon = 'sort-alpha-' + (_this7.sortList[item.props.field] === 'asc' ? 'down' : 'up');
                                }
                                return _react2.default.createElement(
                                    'th',
                                    { 'data-key': 'head_' + key, style: style },
                                    item.props.onSort ? _react2.default.createElement(
                                        'a',
                                        { href: 'javascript://',
                                            onClick: _this7.sortHandler(item.props.field, item.props.onSort) },
                                        item.props.text,
                                        ' ',
                                        _react2.default.createElement(_reactBootstrap.Icon, { icon: sort_icon })
                                    ) : item.props.text,
                                    _this7.props.move ? _react2.default.createElement('span', { className: 'column-split' }) : null
                                );
                            })
                        )
                    )
                )
            );
        }
    }, {
        key: 'renderRows',
        value: function renderRows() {
            var _this8 = this;

            return _react2.default.createElement(
                'div',
                { className: 'flex-grow-1 rows', onScroll: this.scrollHandler },
                _react2.default.createElement(
                    'table',
                    { className: this.getClasses(), style: this.getTableStyles() },
                    _react2.default.createElement(
                        'tbody',
                        null,
                        this.state.data.map(function (row, i) {
                            return _this8.renderRow(row, i);
                        })
                    )
                )
            );
        }
    }, {
        key: 'renderRow',
        value: function renderRow(row, i, parentRow) {
            var _this9 = this;

            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                _react2.default.createElement(
                    'tr',
                    { className: this.props.onClick ? 'click-row' : null, onClick: this.clickHandler(row, i) },
                    this.state.select ? _react2.default.createElement(
                        'th',
                        { width: '20px' },
                        _react2.default.createElement('input', { type: 'checkbox', ref: 'row_' + i, onChange: this.changeHandler(row, i) })
                    ) : null,
                    _react2.default.Children.map(this.props.children, function (item, key) {
                        if (!item || item.props.hide) {
                            return null;
                        }
                        //set style
                        var style = _extends({}, _this9.props.columnStyle);

                        style.textAlign = item.props.align || _this9.props.align;
                        if (item.props.width) {
                            style.width = item.props.width;
                        }
                        //set tree
                        var tree = void 0,
                            parent = void 0;
                        if (item.props.tree) {
                            if (parentRow) {
                                parent = _react2.default.createElement('span', { className: 'mr-4' });
                            }
                            tree = _react2.default.createElement(_reactBootstrap.Icon, { 'data-open': 'close', onClick: function onClick() {
                                    if (typeof _this9.props.onClickTree === 'function') {
                                        _this9.props.onClickTree(row, function (data) {
                                            if (!data) {
                                                return;
                                            }
                                            var tree = _this9.state.tree;
                                            tree[i] = data;
                                            _this9.state.tree = null;
                                            _this9.setState({
                                                tree: tree
                                            });
                                        });
                                    }
                                }, className: 'mr-1 text-primary', icon: 'plus-square', iconType: 'regular' });
                        }

                        if (item.props.children) {
                            return _react2.default.createElement(
                                'td',
                                { className: item.props.className, style: { 'text-align': align }, key: 'col_' + key },
                                parent,
                                tree,
                                _react2.default.cloneElement(item, {
                                    text: item.props.text,
                                    row: row,
                                    value: row[item.props.field]
                                })
                            );
                        } else {
                            return _react2.default.createElement(
                                'td',
                                { style: style, key: 'col_' + key },
                                parent,
                                tree,
                                item.props.onFormat ? item.props.onFormat(row[item.props.field], row) : row[item.props.field]
                            );
                        }
                    })
                ),
                this.props.tree ? this.renderTreeRow(row, i) : null
            );
        }
    }, {
        key: 'renderFoot',
        value: function renderFoot() {
            if (!this.props.foot) {
                return null;
            }
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(_reactBootstrap.Pagination, { current: this.state.page, count: this.state.dataCount, size: 'sm',
                    onSelect: this.selectPageHandler,
                    number: this.props.showNumbers,
                    showPages: this.props.showPages })
            );
        }
    }]);

    return CTable;
}(_react2.default.Component);

CTable.propTypes = {
    theme: _propTypes2.default.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
    headerTheme: _propTypes2.default.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
    headClass: _propTypes2.default.string,
    data: _propTypes2.default.array,
    dataCount: _propTypes2.default.number,
    page: _propTypes2.default.number,
    select: _propTypes2.default.bool,
    header: _propTypes2.default.bool,
    center: _propTypes2.default.bool,
    currentPage: _propTypes2.default.number,
    striped: _propTypes2.default.bool,
    bordered: _propTypes2.default.bool,
    hover: _propTypes2.default.bool,
    sm: _propTypes2.default.bool,
    fontSm: _propTypes2.default.bool,
    responsive: _propTypes2.default.bool,
    align: _propTypes2.default.string,
    tree: _propTypes2.default.string,
    onClickTree: _propTypes2.default.func,
    onClick: _propTypes2.default.func,
    onCheck: _propTypes2.default.func,
    move: _propTypes2.default.bool,
    onRefresh: _propTypes2.default.func,
    refreshText: _propTypes2.default.string,
    absolute: _propTypes2.default.bool,
    x: _propTypes2.default.string,
    y: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    foot: _propTypes2.default.bool,
    position: _propTypes2.default.object,
    showPages: _propTypes2.default.number,
    showNumbers: _propTypes2.default.number,
    onSelectPage: _propTypes2.default.func,
    noWrap: _propTypes2.default.bool
};

CTable.defaultProps = {
    data: [],
    dataCount: 1,
    select: true,
    header: true,
    foot: true,
    currentPage: 1,
    hover: true,
    striped: true,
    align: 'left',
    sm: true,
    fontSm: true,
    headerTheme: 'light',
    noWrap: true
};

exports.default = CTable;
//# sourceMappingURL=CTable.js.map
