/* @clake/react-bootstrap4-window v0.1.2 | by Clake
 * Copyright (c) 2018 Clake,
 * 2018-11-05T16:44:20+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 拖动控制类
 * @author clake
 * @version 0.1
 */

var move = {
    x: 0,
    y: 0
};

var Drag = function () {
    /**
     * 初始化方法
     * @param dragDom  DOMElement|string   拖动对像,可以传入DOM对像或selector字符串
     * @param eventDom DOMElement|string   拖动事件对像,可以传入DOM对像或selector字符串
     * @param events   object              事件对像,可选多个事件
     */
    function Drag(dragDom, eventDom, events) {
        var _this = this;

        _classCallCheck(this, Drag);

        this.beginDrag = function (e) {
            // e.preventDefault();
            if (!_this._evtStart()) {
                return false;
            }

            _this.domX = parseInt(_this.dragDom.style.left);
            _this.domY = parseInt(_this.dragDom.style.top);
            _this.dragX = parseInt(e.pageX);
            _this.dragY = parseInt(e.pageY);

            window.addEventListener('mousemove', _this.moveDrag, false);
            window.addEventListener('mouseup', _this.overDrag, false);
        };

        this.moveDrag = function (e) {
            move.x = _this.domX + (parseInt(e.pageX) - _this.dragX);
            move.y = _this.domY + (parseInt(e.pageY) - _this.dragY);
            if (typeof _this._evtMove === "function") {
                _this._evtMove(move);
            }
            _this.dragDom.style.top = move.y + 'px';
            _this.dragDom.style.left = move.x + 'px';
        };

        this.overDrag = function (e) {
            window.removeEventListener('mousemove', _this.moveDrag);
            window.removeEventListener('mouseup', _this.overDrag);
            _this._evtEnd();
        };

        this.dragX = 0;
        this.dragY = 0;
        this.domX = 0;
        this.domY = 0;
        this.x = 0;
        this.y = 0;

        if (dragDom instanceof HTMLElement) {
            this.dragDom = dragDom;
        } else if (typeof dragDom === "string") {
            this.dragDom = document.querySelector(dragDom);
        } else {
            throw "dragDom must be selector string or HTMLElement object";
        }

        if (eventDom instanceof HTMLElement) {
            this.eventDom = eventDom;
        } else if (typeof eventDom === 'string') {
            this.eventDom = document.querySelector(eventDom);
        } else {
            this.eventDom = dragDom;
        }

        this.eventDom = eventDom || dragDom;
        this.initEvents(events || {});
        this.bindEvents();
    }

    _createClass(Drag, [{
        key: "initEvents",
        value: function initEvents(events) {
            this._evtStart = events.start || defaultEvent;
            this._evtMove = events.move || null;
            this._evtEnd = events.end || defaultEvent;
        }
    }, {
        key: "bindEvents",
        value: function bindEvents() {
            this.eventDom.addEventListener("mousedown", this.beginDrag, false);
        }
    }, {
        key: "unbind",
        value: function unbind() {
            this.eventDom.removeEventListener('mousedown', this.beginDrag);
        }
    }]);

    return Drag;
}();

exports.default = Drag;


function defaultEvent() {
    return true;
}
//# sourceMappingURL=Drag.js.map
